//************************************************************************************************
//
//    NOMBRE DEL ARCHIVO: CMatriz.cpp
//    MDULO:
//    FECHA: 30-04-01
//    AUTOR: Arturo Gil Aparicio
//    DESCRIPCIN: Implementacin de la clase CMatriz
//
//************************************************************************************************

#define __CMATRIZ_CPP__

//Libreras Estndar
#include <iostream.h>

//Otras libreras


//Encabezado Mdulo-Proyecto

//Encabazado del archivo
#include "..\inc\CMatriz.h"

//Variables Globales externas

//Variables Globales internas


CMatriz::CMatriz(int filas, int columnas)
{
		fil = filas;
		col = columnas;
	//filas
		mat = new CComplejo*[fil];
        
		//columnas
		for(int i=0; i < fil; i++)
			mat[i]= new CComplejo[col];		
}

CMatriz::CMatriz(CMatriz& orig)
{
	int i, j;
	
	fil = orig.fil;
	col = orig.col;
	//filas
	mat = new CComplejo*[orig.fil];
        
		//columnas
	for(i=0; i < orig.fil; i++)
			mat[i]= new CComplejo[orig.col];
		
	for(i = 0; i < orig.fil; i++)
		for(j=0; j < orig.col; j++)
			mat[i][j]=orig.mat[i][j];
}

CMatriz::~CMatriz()
{
	
	for(int i=0; i < fil; i++)
			delete []mat[i];

	delete [] mat;
}

void CMatriz::Visualizar()
{  
	int i, j;

	cout << endl;

   	for(i = 0; i < fil; i++)
	{
		cout << endl;
			for(j=0; j < col; j++)
			{
			         mat[i][j].Visualizar();
				cout << "\t";
            }
	}
}

void CMatriz::IntroducirValores()
{  
	int i, j;

	cout << endl<< "Introduzca los elementos de la matriz: "<<endl;

   	for(i = 0; i < fil; i++)
	{
		for(j=0; j < col; j++){
			cout << "Introduzca el elemento (" << i << ", " << j <<") "<< endl;
			mat[i][j].IntroducirValores();
			//cin >> mat[i][j];
		}
		cout << endl;
	}
}


CMatriz CMatriz::operator + (CMatriz &der)
{
	CMatriz suma(*this);
	int i, j;

	if((fil!=der.fil)||(col !=der.col))
		cout << endl << "No se pueden sumar las matrices";

	else{
	
		for(i = 0; i < der.fil; i++)
			for(j=0; j < der.col; j++)
				suma.mat[i][j]=mat[i][j]+der.mat[i][j];
	
	}
	
	return suma;
}

CMatriz CMatriz::operator - (CMatriz &der)
{
	CMatriz suma(*this);
	int i, j;

	if((fil!=der.fil)||(col !=der.col))
		cout << endl << "No se pueden restar las matrices";

	else{
	
		for(i = 0; i < der.fil; i++)
			for(j=0; j < der.col; j++)
				suma.mat[i][j]=mat[i][j]-der.mat[i][j];
	
	}
	
	return suma;
}

CMatriz CMatriz::operator * (CMatriz &der)
{
	int i, j, k;
	CMatriz prod(fil, der.col);

	if(col!=der.fil)
		cout << endl << "No se pueden multiplicar las matrices";

	else{
	
		for(i = 0; i < fil; i++)
			for(j=0; j < der.col; j++)
			{
				prod.mat[i][j]=0.0;
				for(k=0; k < col; k++)
					prod.mat[i][j]=prod.mat[i][j] + mat[i][k]*der.mat[k][j];
			}
	
	}
	
	return prod;
}




CMatriz& CMatriz::operator = (const CMatriz &der)
{
	int i, j;

	if((fil!=der.fil)||(col !=der.col))
		cout << endl << "No se pueden igualar matrices de dimensiones distintas";

	else{
	
		for(i = 0; i < der.fil; i++)
			for(j = 0; j < der.col; j++)
				mat[i][j]=der.mat[i][j];
	
	}
	
	return (*this);
}

