//************************************************************************************************
//
//    NOMBRE DEL ARCHIVO: Complejo.cpp
//    MDULO:
//    FECHA: 15-06-07
//    AUTOR: Arturo Gil Aparicio
//    DESCRIPCIN: Implementacin de la clase CComplejo
//
//************************************************************************************************

#define __COMPLEJO_CPP__

//Libreras Estndar
#include <iostream.h>
#include <math.h>

//Otras libreras


//Encabezado Mdulo-Proyecto

//Encabazado del archivo
#include "..\inc\Complejo.h"

//Variables Globales externas

//Variables Globales internas




//**********************************************************************
//
//	NOMBRE: CComplejo::CComplejo
//	VARIABLES GLOBALES:
//	VARIABLES DE SALIDA:
//	COMENTARIOS (PARMETROS): Constructor por defecto. Inicializa el
//							  numero a 0 + 0i
//
//**********************************************************************
CComplejo::CComplejo(void)
{
	real = 0.0;
	imag = 0.0;
}

//**********************************************************************
//
//	NOMBRE: CComplejo::CComplejo
//	VARIABLES GLOBALES:
//	VARIABLES DE SALIDA:
//	COMENTARIOS (PARMETROS): Constructor a partir de 2 reales
//
//**********************************************************************
CComplejo::CComplejo(float num_real, float num_imag)
{
	real = num_real;
	imag = num_imag;
}

//**********************************************************************
//
//	NOMBRE: CComplejo::CComplejo
//	VARIABLES GLOBALES:
//	VARIABLES DE SALIDA:
//	COMENTARIOS (PARMETROS): constructor copia
//
//**********************************************************************
CComplejo::CComplejo(const CComplejo &compl_orig)	
{
	real = compl_orig.real;
	imag = compl_orig.imag;
}

//**********************************************************************
//
//	NOMBRE: CComplejo::~CComplejo
//	VARIABLES GLOBALES:
//	VARIABLES DE SALIDA:
//	COMENTARIOS (PARMETROS): destructor
//
//**********************************************************************
CComplejo::~CComplejo(void)					
{
	
}

//**********************************************************************
//
//	NOMBRE: CComplejo::operator =
//	VARIABLES GLOBALES:
//	VARIABLES DE SALIDA: referencia al valor asignado
//	COMENTARIOS (PARMETROS): operador asignacin 
//
//**********************************************************************
CComplejo& CComplejo::operator = (const CComplejo & compl_orig)	
{
	real = compl_orig.real;
	imag = compl_orig.imag;
	return (*this);	// this es un puntero predefinido al objeto actual
}


//***************************************************************************************
//    Nombre: CComplejo::AsignarReal
//    Variables globales: 
//    Variables de salida:
//    Comentarios (parmetros): Asigna la parte real del nmero complejo.
//***************************************************************************************
void CComplejo::AsignarReal(float num_real)
{
	real = num_real;
}

//***************************************************************************************
//    Nombre: CComplejo::AsignarImag
//    Variables globales: 
//    Variables de salida:
//    Comentarios (parmetros): Asigna la parte imaginaria del nmero complejo.
//***************************************************************************************
void CComplejo::AsignarImag(float num_imag)
{
	imag = num_imag;
}

//***************************************************************************************
//    Nombre: CComplejo::Visualizar
//    Variables globales: 
//    Variables de salida:
//    Comentarios (parmetros): Visualiza en pantalla el nmero complejo
//***************************************************************************************
void CComplejo::Visualizar(void)
{
	if (imag<0){
		cout << real << imag << "i";
	}
	else if(imag==0){	
                     cout << real;
         }
	else if(real==0){	
                     cout << imag << "i";
         }
    else{
		cout << real << "+" << imag << "i";
	}
}

//***************************************************************************************
//    Nombre: CComplejo::Visualizar
//    Variables globales: 
//    Variables de salida:
//    Comentarios (parmetros): Visualiza en pantalla el nmero complejo
//***************************************************************************************
void CComplejo::IntroducirValores(void)
{
     cout << endl << "Introduzca la parte real: ";
     cin >> real;
     cout << endl << "Introduzca la parte imaginaria: ";
     cin >> imag;
}

//***************************************************************************************
//    Nombre: operator +
//    Variables globales: 
//    Variables de salida: Nmero complejo
//    Comentarios (parmetros): Suma dos nmeros complejos
//***************************************************************************************
CComplejo CComplejo::operator + (const CComplejo &a)
{
	CComplejo suma;
		
	suma.real = real + a.real;
	suma.imag = imag + a.imag;
	
	return (suma);
}

//***************************************************************************************
//    Nombre: operator -
//    Variables globales: 
//    Variables de salida: Nmero complejo
//    Comentarios (parmetros): Resta dos nmeros complejos
//***************************************************************************************
CComplejo CComplejo::operator - (const CComplejo &a)
{
	CComplejo suma;
		
	suma.real = real - a.real;
	suma.imag = imag - a.imag;
	
	return (suma);
}

//***************************************************************************************
//    Nombre: operator *
//    Variables globales: 
//    Variables de salida: Nmero complejo
//    Comentarios (parmetros): Multiplica dos nmeros complejos
//***************************************************************************************
CComplejo CComplejo::operator * (const CComplejo &a)
{
	CComplejo suma;
		
	suma.real = real*a.real-imag*a.imag;
	suma.imag = real*a.imag + imag*a.real;
	
	return (suma);
}


